#!/usr/bin/perl -w

#--------------------------------------------------------------------
# FICHERO:  cd-ejemplo.pl
# OBJETIVO: Crear un cuadro de dilogo de ejemplo
# AUTOR:    Pedro Reina
# FECHA:    X.4.7.2001
#--------------------------------------------------------------------

#---------------------------------
# Declaracin de mdulos
#---------------------------------

use strict;              # Comprobaciones estrictas
use Gtk;                 # Interfaz grfico GTK

#---------------------------------
# Declaracin de variables Perl
#---------------------------------

#my $TextoApt;            # El texto que se manda a apt-cache

#---------------------------------
# Declaracin de variables GTK
#---------------------------------

my $Ventana;             # Ventana de la aplicacin
my $Cuaderno;            # Conjunto de fichas
my $CuadroTamano;        # Un marco para la seccin Tamao
my $CuadroOrientacion;   # Un marco para la seccin Orientacin
my $BotonAceptar;        # El botn para cerrar la aplicacin
my $BotonCancelar;       # El botn para anular la aplicacin
my $BotonOpciones;       # El botn para mosquear de opciones
my $Caja;                # Un contenedor para los controles
my $TablaTamano;         # Tabla para los controles de tamao
my $CajaOrientacion;     # Caja para los controles de orientacin
my $CajaBotones;         # Un contenedor para poner los botones de abajo
my $AjusteAncho;         # El ajuste "Ancho"
my $AjusteAlto;          # El ajuste "Alto"
my $EntradaAncho;        # El nmero "Ancho"
my $EntradaAlto;         # La etiqueta "Alto"
my $EtiquetaAlto;        # El nmero "Alto"
my $EtiquetaAncho;       # La etiqueta "Ancho"
my $BotonH;              # Casilla de verificacin "Horizontal"
my $BotonV;              # Casilla de verificacin "Vertical"

#---------------------------------
# Programa principal
#---------------------------------

# Arrancamos el motor GTK;
init Gtk;

# Creamos la ventana principal
$Ventana = new Gtk::Window ("toplevel");

# Le ponemos un ttulo
$Ventana->set_title ("Preparar pgina");

# Le ponemos un poquito de borde
$Ventana->border_width (10);

# Definimos el tamao que nos gusta
#$Ventana->set_usize (600, 400);


# Creamos un cuaderno
$Cuaderno = new Gtk::Notebook();

# Lo aadimos a la ventana
$Ventana->add ($Cuaderno);

# Y lo mostramos
$Cuaderno->show();


# Creamos la caja para poner los controles
$Caja = new Gtk::HBox (0, 10);

# Le ponemos un poquito de borde
$Caja->border_width (10);


# Creamos dos cuadros
$CuadroTamano = new Gtk::Frame ("Tamao");
$CuadroOrientacion = new Gtk::Frame ("Orientacin");

# Los aadimos a la caja
$Caja->add ($CuadroTamano);
$Caja->add ($CuadroOrientacion);

# Y los mostramos
$CuadroTamano->show();
$CuadroOrientacion->show();

# Creamos una tabla y una caja
$TablaTamano = new Gtk::Table (2, 2, 0);
$CajaOrientacion = new Gtk::VBox (0, 5);

# Les ponemos un poquito de borde
$TablaTamano->border_width (5);
$TablaTamano->set_row_spacing (0, 3);
$TablaTamano->set_col_spacing (0, 3);
$CajaOrientacion->border_width (5);

# Las aadimos a los cuadros
$CuadroTamano->add ($TablaTamano);
$CuadroOrientacion->add ($CajaOrientacion);

# Y las mostramos
$TablaTamano->show();
$CajaOrientacion->show();

# Creamos los ajustes Ancho y Alto
$AjusteAncho = new Gtk::Adjustment (21.0, 15.0, 25.0, 0.1, 1.0, 0.0);
$AjusteAlto = new Gtk::Adjustment (29.7, 15.0, 35.0, 0.1, 1.0, 0.0);

# Creamos las entradas Ancho y Alto
$EntradaAncho = new Gtk::SpinButton ($AjusteAncho, 0, 1);
$EntradaAlto = new Gtk::SpinButton ($AjusteAlto, 0, 1);
#$EntradaAncho = new Gtk::Entry (5);
#$EntradaAlto = new Gtk::Entry (5);

# Creamos las etiquetas Ancho y Alto
$EtiquetaAncho = new Gtk::Label ("Ancho");
$EtiquetaAlto = new Gtk::Label ("Alto");
$EtiquetaAncho->set_justify ('left');
$EtiquetaAlto->set_justify ('left');

# Aadimos la entrada a la tabla Tamao
$TablaTamano->attach_defaults ($EtiquetaAncho, 0, 1, 0, 1);
$TablaTamano->attach_defaults ($EntradaAncho, 1, 2, 0, 1);
$TablaTamano->attach_defaults ($EtiquetaAlto, 0, 1, 1, 2);
$TablaTamano->attach_defaults ($EntradaAlto, 1, 2, 1, 2);

# Mostramos las entradas
$EtiquetaAncho->show();
$EtiquetaAlto->show();
$EntradaAncho->show();
$EntradaAlto->show();

# Creamos dos botones de opcin
$BotonH = new Gtk::RadioButton ("Horizontal");
$BotonV = new Gtk::RadioButton ("Vertical", $BotonH);

# Los aadimos a la caja Orientacin
$CajaOrientacion->pack_start ($BotonV, 0, 0, 2);
$CajaOrientacion->pack_start ($BotonH, 0, 0, 2);

# Los mostramos
$BotonH->show();
$BotonV->show();

# Creamos la caja para poner los botones
$CajaBotones = new Gtk::VBox (0, 5);

# Definimos los botones
$BotonAceptar = new Gtk::Button ("Aceptar");
$BotonCancelar = new Gtk::Button ("Cancelar");
$BotonOpciones = new Gtk::Button ("Opciones...");

# Aadimos los botones a la caja de botones
$CajaBotones->pack_start ($BotonAceptar, 1, 1, 0);
$CajaBotones->pack_start ($BotonCancelar, 1, 1, 0);
$CajaBotones->pack_start ($BotonOpciones, 1, 1, 0);

# Mostramos los botones
$BotonAceptar->show();
$BotonCancelar->show();
$BotonOpciones->show();

# Aadimos la caja de botones a la caja
$Caja->pack_start ($CajaBotones, 0, 0, 2);

# Mostramos la caja de botones
$CajaBotones->show();

# Registramos las llamadas para cerrar la aplicacin
$Ventana->signal_connect ("delete_event", \&CerrarAplicacion);
$BotonAceptar->signal_connect ("clicked", \&CerrarAplicacion);
$BotonCancelar->signal_connect ("clicked", \&CerrarAplicacion);


# Aadimos la caja a la ventana
#$Ventana->add ($Caja);

# Mostramos la caja
$Caja->show();

# Aadimos la caja al cuaderno
$Cuaderno->append_page ($Caja, new Gtk::Label ("Mrgenes"));
$Cuaderno->append_page ($Caja, new Gtk::Label ("Tamao de papel"));
$Cuaderno->append_page ($Caja, new Gtk::Label ("Fuente del papel"));
$Cuaderno->append_page ($Caja, new Gtk::Label ("Diseo de pgina"));

# Activamos la ficha deseada
$Cuaderno->set_page (1);


# Mostramos la ventana
$Ventana->show();

# El resto es cosa de GTK
main Gtk;

# As que hasta aqu no se debera llegar nunca
exit (0);

#---------------------------------
# Funciones
#---------------------------------

sub CerrarAplicacion
  {
  Gtk->exit (0);
  return (0);
  }

